/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2009 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_config.h 759 2008-05-24 17:01:20Z roi $
 */

/*
 *		ƥ¸⥸塼H8/300Hѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_CORE_CONFIG_H
#define TOPPERS_CORE_CONFIG_H

#include "h8300h_gcc/h8300h.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ƥü̿Υ饤ؿ
 */
#include "h8300h_gcc/core_insn.h"

#include <sil.h>

/*
 *  󥿥ƥѤΥå
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char *)(istk) + (istksz)))

/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
	void	*sp;		/* åݥ */
	FP		pc;			/* ץ५ */
} CTXB;


/*
 *  H8/300Hϥե̿᤬٤1ӥåȤĤեȤǤʤˤᡢ
 *  07ӥåȥեȤ̤ͽᡢROMΰ˳ǼƤ
 */
extern const uint8_t h8_bitshift[];
extern const uint8_t h8_neg_bitshift[];

#endif /* TOPPERS_MACRO_ONLY */


/*
 *  ͥ٥ޥ饤֥
 *
 *  H8/300H¸ǤϡSYSCR쥸UEӥå=0Ȥơǥ
 *  ɥ쥸CCRˤUIӥåȡʥӥå6ˤͭˤCCR쥸
 *  Iӥåȡʥӥå7ˡUIӥåȡʥӥå6ˤʻƳߥޥӥ
 *  ȤȤƻѤƤ롣
 *  γߥޥӥåȤϥӥåȥѥǤꡢñ˳ͥ٥
 *  IPM˥եȱ黻ǤѴǤʤ
 *  
 *٥룰٤Ƥγߤդ
 *٥룱NMIӥץ饤ƥ٥룱γߤΤߤ
 *դ
 *٥룲NMIʳγߤդʤ
 *  
 *  Ѹ
 *  ɽIPMˡǥγͥ٥ޥIPM
 *  ɽIIPM)CCRꤹӥåȥѥ
 *  
 *  ͥ٥ޥɽIIPMȽ񤯤Ȥˤ롥
 */

/*
 *  ٥룰٤Ƥγߤդ
 */
#define IIPM_LEVEL0      0U

/*
 *  ٥룱NMIӥץ饤ƥ٥룱γߤΤߤդ
 */
#define IIPM_LEVEL1      H8CCR_I

/*
 *  ٥룲NMIʳγߤդʤ
 */
#define IIPM_LEVEL2      (H8CCR_I | H8CCR_UI)

/*
 *  ػߤγɽ
 */
#define TIPM_DISALL		(-2)

/*
 *  TIPM_DISALLʳػߡˤɽ
 */
#define IIPM_DISALL		UINT8_C(0xc0)	/*  IӥåȤUIӥåȤΤ1  */

/*
 *  TIPM_ENAALLʳͥ٥ޥˤɽ
 */
#define IIPM_ENAALL		UINT8_C(0)

/*
 *  ͥ٥ޥγɽɽѴ
 *
 *  ֥ΥեǤϻѤʤ
 */
#ifndef TOPPERS_MACRO_ONLY

/* ɽɽ */
Inline PRI
ext_ipm(IIPM iipm)
{
	PRI ipm = 0;
	
	switch (iipm) {
		case IIPM_LEVEL0:
			ipm = 0;
			break;
		case IIPM_LEVEL1:
			ipm = -1;
			break;
		case IIPM_LEVEL2:
			ipm = -2;
			break;
		default:
			assert("ext_ipm: Invalid IIPM");
			break;
	}
	return(ipm);
}

extern const IIPM int_ipm_table[];

/* ɽɽ */
Inline IIPM
int_ipm(PRI ipm)
{
	IIPM iipm;

	assert((-2 <= ipm) && (ipm <= 0));
	iipm = int_ipm_table[-ipm];
	return(iipm);
}


/*  ֥Ѵޥ  */

/*
 *  IIPMʳߥޥɽˤθͤɽФ
 */
Inline IIPM
current_iipm(void)
{
	IIPM iipm;
	uint8_t ccr = current_ccr();
	iipm = (IIPM)(ccr & H8CCR_INT_MASK_BIT);
	return(iipm);
}

/*
 *  IIPMʳߥޥɽˤθͤ
 *
 *CCRIӥåȡUIӥåȰʳξե饰¸ʤ
 */
#define set_iipm(iipm)	set_ccr((uint8_t)(iipm))

/*
 *  TOPPERSɸ߽ǥμ¸
 *
 *  H8/300Hϡǥ󥳡ɥ쥸CCR˳ߥޥ
 *  ʥϡɥγߥޥǤϤʤӥåȥѥˤ
 *  Ƥ뤬CPUåե饰뵡ǽʤΤᡤCPU
 *  åե饰εǽIPMˤäƼ¸롥
 *
 *  ޤCPUåե饰͡ʤʤCPUå֡ˤϡΤ
 *  lock_flagˤѰդݻ롥
 *
 *  CPUåե饰ꥢƤ֡ʤʤCPUå֤
 *  ֡ˤϡIPMʥϡɥγͥ٥ޥˤ򡤥ǥγ
 *  ͥ٥ޥͤꤹ롥δ֤ϡǥγͥ٥ޥ
 *  ϡIPMѤݻ롥
 *
 *  ФCPUåե饰åȤƤ֡ʤʤCPU
 *  ֤δ֡ˤϡIPMʥϡɥγͥ٥ޥˤ򡤥ͥ
 *  ΤΤ٤Ƥγ׵ޥ͡TIPM_LOCKˤȡ
 *  ǥγͥ٥ޥȤι⤤ꤹ롥δ֤Υǥ
 *  γͥ٥ޥϡΤѿsaved_iipmɽݻ
 *  Ѱդݻ롥
 */

/*
 *  ߥͥȥ
 */
extern uint8_t intnest;

/*
 *  ƥȤλ
 *
 *  H8/300HǤϡߥͥȥ󥿤ͤǥƥȤȽ̤롣
 *  ߥͥȥ󥿤ɤ߽Фľ˳ߤȯƤ⡢ä
 *  ˤϥƥȤ⸵äƤ롣
 */
Inline bool_t
sense_context(void)
{
	bool_t ret;

	if (intnest != 0U) {
		ret = true;
	}
	else {
		ret = false;
	}
	return(ret);
}

/*
 *  CPUåե饰¸Τѿ
 *
 *  ѿϡCPUå֤λΤ߽񤭴Ƥ褤ΤȤ롥
 */
extern bool_t lock_flag;	/* CPUåե饰ͤݻѿ */
extern IIPM   saved_iipm;	/* ͥ٥ޥ¸ѿ */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  CPUå֤Ǥγͥ٥ޥ
 *
 *  TIPM_LOCKϡCPUå֤Ǥγͥ٥ޥʤ
 *  ΤΤ٤Ƥγ׵ޥͤ롥
 *
 *  TIPM_LOCK=-1٥2γߤͥȤʤ롥
 *  TIPM_LOCK=-2NMIʳ˥ͥγߤߤʤ
 */
#ifndef TIPM_LOCK
#define TIPM_LOCK	(-2)	/* NMIʳ˥ͥγߤߤʤ */
#endif /* TIPM_LOCK */

/*
 *  CPUå֤Ǥγͥ٥ޥɽ
 */
#if TIPM_LOCK == -1
#define IIPM_LOCK	IIPM_LEVEL1
#elif TIPM_LOCK == -2
#define IIPM_LOCK	IIPM_LEVEL2
#else	/*  #elif TIPM_LOCK == -2  */
#error illegal TIPM_LOCK !
#endif	/*  #if TIPM_LOCK == -1  */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  CPUå֤ؤΰܹ
 *
 *  IPMʥϡɥγͥ٥ޥˤsaved_iipm¸
 *  ͥγߤ򤹤٤ƥޥ͡TIPM_LOCKˤꤹ롥ޤ
 *  lock_flagtrueˤ롥
 *
 *  IPMǽ餫TIPM_LOCKƱ⤤ˤϡ
 *  saved_iipm¸ΤߤǡTIPM_LOCKˤꤷʤϡǥ
 *  γͥ٥ޥTIPM_LOCKƱ⤤٥
 *  Ƥ֤ˤ롥
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǸƤФ뤳Ȥ
 *  ʤΤꤷƤ롥
 */
Inline void
x_lock_cpu(void)
{
	IIPM	iipm;

	/*
	 *  current_iipm()֤ͤľsaved_iipm¸ѿiipm
	 *  ѤƤΤϡcurrent_iipm()Ƥľ˳ߤȯ
	 *  ư줿߽saved_iipmѹǽ뤿
	 *  롥
	 */
	iipm = current_iipm();
#if TIPM_LOCK == TIPM_DISALL	/*  ͥγߤʤ  */
	disint();
#else /* TIPM_LOCK == TIPM_DISALL */
								/*  ͥγߤ  */
								/*  TIPM_LOCK=-1  */
	/*
	 *  TIPM_LOCK=-1ʤΤǡiipmTIPM_LOCK㤤Τϡ
	 *  iipm=IIPM_LEVEL0ΤȤΤߤǤ롣
	 *  	iipm=IIPM_LEVEL0ΤȤIIPMIIPM_LEVEL1ꤹ롣
	 *  	iipm=IIPM_LEVEL1ΤȤΤޤ
	 *  	iipm=IIPM_LEVEL2ΤȤΤޤ
	 */
	if (iipm == IIPM_LEVEL0) {
		set_iipm(IIPM_LOCK);
	}
#endif /* TIPM_LOCK == TIPM_DISALL */
	saved_iipm = iipm;
	lock_flag = true;
}

#define t_lock_cpu()	x_lock_cpu()
#define i_lock_cpu()	x_lock_cpu()

/*
 *  CPUå֤β
 *
 *  lock_flagfalseˤIPMʥϡɥγͥ٥ޥˤ
 *  saved_iipm¸᤹ͤ
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǤΤ߸ƤФ
 *  ΤꤷƤ롥
 */
Inline void
x_unlock_cpu(void)
{
	lock_flag = false;
	set_iipm(saved_iipm);
}

#define t_unlock_cpu()	x_unlock_cpu()
#define i_unlock_cpu()	x_unlock_cpu()

/*
 *  CPUå֤λ
 */
#define x_sense_lock()	lock_flag

#define t_sense_lock()	x_sense_lock()
#define i_sense_lock()	x_sense_lock()

/*
 *  chg_ipmͭʳͥ٤ϰϤȽ
 *
 *  TMIN_INTPRIͤˤ餺chg_ipmǤϡ-2TIPM_ENAALLʡ0ˤϰ
 *  Ǥ뤳ȤȤʥåγĥˡ
 */
#define VALID_INTPRI_CHGIPM(intpri) \
				((-2 <= (intpri) && (intpri) <= TIPM_ENAALL))

/*
 * ʥǥΡ˳ͥ٥ޥ
 *
 *  CPUåե饰ꥢƤϡϡɥγͥ٥
 *  ꤹ롥CPUåե饰åȤƤϡsaved_iipm
 *  ꤷˡϡɥγͥ٥ޥꤷ褦
 *  ʥǥΡ˳ͥ٥ޥTIPM_LOCKι⤤ꤹ롥
 */
Inline void
x_set_ipm(PRI intpri)
{
	IIPM	iipm = int_ipm(intpri);

	if (!lock_flag) {		/*  CPUå  */
		set_iipm(iipm);
	}
	else {					/*  CPUå  */
		saved_iipm = iipm;
#if TIPM_LOCK == TIPM_DISALL	/*  ͥγߤʤ  */
		/*
		 *  TIPM_LOCKTIPM_DISALLξˤϡλǥϡɥ
		 *  ͥ٥ޥɬIIPM_DISALLꤵƤ뤿ᡤ
		 *  ꤷľɬפʤ
		 */
#else /* TIPM_LOCK == TIPM_DISALL */
								/*  ͥγߤ  */
								/*  TIPM_LOCK=-1  */
		if (intpri < TIPM_LOCK) {
						/*  TIPM_LOCK⤤٥뤬ꤵ줿  */
			/*  intpri򤽤Τޤꤹ롣  */
		}
		else {		/*  TIPM_LOCK㤤٥뤬ꤵ줿  */
			/*
			 *  츫⤷ʤơIPMΤޤޤǡɤ
			 *  chg_ipm(-2)θchg_ipm(0)ꤷơ
			 *  ǰΤᡢIPMTIPM_LOCKꤷľ
			 */
			iipm = IIPM_LOCK;
		}
		set_iipm(iipm);
#endif /* TIPM_LOCK == TIPM_DISALL */
	}
}

#define t_set_ipm(intpri)	x_set_ipm(intpri)
#define i_set_ipm(intpri)	x_set_ipm(intpri)

/*
 * ʥǥΡ˳ͥ٥ޥλ
 *
 *  CPUåե饰ꥢƤϥϡɥγͥ٥
 *  򡤥åȤƤsaved_iipm򻲾Ȥ롥
 */
Inline PRI
x_get_ipm(void)
{
	IIPM	iipm;
	PRI		pri;

	if (!lock_flag) {
		iipm = current_iipm();
	}
	else {
		iipm = saved_iipm;
	}
	pri = ext_ipm(iipm);
	return(pri);
}

#define t_get_ipm()		x_get_ipm()
#define i_get_ipm()		x_get_ipm()

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ֹϰϤȽ
 */

/*  IRQȤͭʳֹȽ  */
#define VALID_INTNO_IRQ(intno)	\
		((TMIN_INTNO_IRQ <= (intno)) && ((intno) <= TMAX_INTNO_IRQ))

/*  ׵ػߥե饰ݡȤֹȽ  */
#define VALID_INTNO_DISINT(intno)	VALID_INTNO_IRQ(intno)

/*
 *  ֹintnoбIPRA, IPRB쥸Υӥåֹ档
 *  
 *    ͭʳֹǤСͭʥӥåֹ椬ǼƤ롣
 */
#ifndef TOPPERS_MACRO_ONLY
extern const uint8_t ipr_bit[];
#endif /* TOPPERS_MACRO_ONLY */

#define DUMMY_IPR_BIT		0xffU	/*  ߡΥӥåֹ  */
#define NMI_IPR_BIT			0xf0U	/*  ߡΥӥåֹNMI  */

/*
 *  CFG_INT()ͭʳֹ椫ɤȽ
 *  աNMIޤࡣ
 */
#define VALID_INTNO_CFGINT(intno)									\
	(((intno) < TMAX_INTNO) && (ipr_bit[intno] != DUMMY_IPR_BIT))

/*  ATT_ISR()ͭʳֹ椫ɤȽ  */
#define VALID_INTNO_ATTISR(intno)	VALID_INTNO_CFGINT(intno)

/*
 *  ֹбߥϥɥֹޥ
 */
#define TINHNO(intno)	(INHNO)(intno)

/*
 *  IRQ׵Υꥢ
 *  1١ɤߤơꥢӥåȤ0񤭹ࡣ
 *  ʤ¾ΥӥåȤˤ1񤭹ࡣ
 *  ISRɤ߽ФͤȤȡߥ󥰤ˤäƤ
 *  طʤӥåȤޤǥꥢƤޤ
 *  
 *  bclr̿ȤСȥߥå̿ʤΤǡ
 *  ǳߤդʤ
 */
#define h8_clr_irq(irq)	bitclr((uint8_t *)H8ISR, irq)

/*
 *  IRQ׵ζػ
 *  bclr̿ȤСȥߥå̿ʤΤǡ
 *  ǳߤդʤ
 */
#define h8_disint_irq(irq)	bitclr((uint8_t *)H8IER, irq)

/*
 *  IRQ׵ε
 *  bset̿ȤСȥߥå̿ʤΤǡ
 *  ǳߤդʤ
 */
#define h8_enaint_irq(irq)	bitset((uint8_t *)H8IER, irq)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 *  
 *  IRQnꤵƤСѿnӥåܤ
 *  CFG_INT()ξ򸵤˥ե졼롣
 *  x_enable_int, x_disable_intѤ롣
 *  IRQˤĤƤΤ߾ݻ롣
 *  IRQ0IRQ56װΤ
 *  ¢ڥեˤĤƤݻʤ
 */
extern const uint8_t	bitptn_cfgint;

/*
 *  ׵ػߥե饰Υå
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥻥åȤ褦Ȥˤϡfalse֤
 *
 *VALID_INTNO_DISINT(intno)trueˤʤintnoФƤΤ߸ƤФ롣
 *  intnoIRQ˳롣
 *  ¢ڥեǤϤʤ
 */
#define TOPPERS_SUPPORT_DIS_INT			/* dis_int򥵥ݡȤ */

Inline bool_t
x_disable_int(INTNO intno)
{
	uint8_t irq = (uint8_t)(intno - TINTNO_IRQ0);
	uint8_t bitptn = h8_bitshift[irq];

	/*
	 *׸Ƥ
	 *  νbtst(bit test)̿Ȥ®ʤ뤬
	 *  ʤΤǡCǽ񤤤Ƥ롣
	 */
	if ((bitptn_cfgint & bitptn) == 0U) {
		return false;		/*  °ꤵƤʤ  */
	}
	h8_disint_irq(irq);
	return true;
}

#define t_disable_int(intno)	x_disable_int(intno)
#define i_disable_int(intno)	x_disable_int(intno)

/*
 *  ׵ػߥե饰Υꥢ
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 *
 *VALID_INTNO_DISINT(intno)trueˤʤintnoФƤΤ߸ƤФ롣
 *  intnoIRQ˳롣
 *  ¢ڥեǤϤʤ
 */
#define TOPPERS_SUPPORT_ENA_INT			/* ena_int򥵥ݡȤ */

Inline bool_t
x_enable_int(INTNO intno)
{
	uint8_t irq = (uint8_t)(intno - TINTNO_IRQ0);
	uint8_t bitptn = h8_bitshift[irq];

	if ((bitptn_cfgint & bitptn) == 0U) {
		return false;		/*  °ꤵƤʤ  */
	}
	h8_enaint_irq(irq);
	return true;
}

#define t_enable_int(intno)		x_enable_int(intno)
#define i_enable_int(intno)		x_enable_int(intno)

/*
 *  ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
	uint8_t irq;
	
	if (VALID_INTNO_IRQ(intno)) {
		/*  ׸Ƥåȥꥬ٥ȥꥬȽ̤򤷤Ƥʤ  */
		irq = (uint8_t)(intno - TINTNO_IRQ0);
		h8_clr_irq(irq);
	}
}

#define t_clear_int(intno)		x_clear_int(intno)
#define i_clear_int(intno)		x_clear_int(intno)

/*
 *  ׵Υå
 */
Inline bool_t
x_probe_int(INTNO intno)
{
	uint8_t irq, isr;
	
	if (!VALID_INTNO_IRQ(intno)) {	/*  IRQʳб  */
		return false;
	}
	irq = (uint8_t)(intno - TINTNO_IRQ0);
	isr = sil_reb_mem((void *)H8ISR);
	isr &= h8_bitshift[irq];
	if (isr == 0U) {
		return false;
	} else {
		return true;
	}
}

#define t_probe_int(intno)		x_probe_int(intno)
#define i_probe_int(intno)		x_probe_int(intno)

/*
 *  ׵饤°
 *
 *VALID_INTNO_CFGINT(intno)trueȤʤintnoФƤΤ߸ƤФ롥
 *  H8/300HǤϡͥǰͥ٤2ʳǤ뤿ᡤintpri
 *  ȤͿ뤳ȤǤͤ-2-1Ǥ롥
 *  ֹ椬NMI˳ϡͥintpriϻѤʤ
 */
extern void	x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ߥϥɥɬפIRC
 *
 *  IRQߤɤi_clear_int()Ƚ̤Ƥ롣
 *  ׸Ƥåȥꥬ٥ȥꥬȽ̤򤷤Ƥʤ
 */
Inline void
i_begin_int(INTNO intno)
{
		i_clear_int(intno);
}

/*
 *  ߥϥɥνиɬפIRC
 *
 *  H8/300HǤɬפIRCϤʤ
 *  饤ؿˤȰ̤ѤǤݤηٹ𤬽ФΤǡ
 *  ޥȤƤ롣
 */
#define i_end_int(intno)


/*
 *  ǹ̥ͥؤΥǥѥåcore_support.S
 *
 *  dispatchϡƥȤƤӽФ줿ӥ
 *  ƤӽФ٤ΤǡƥȡCPUå֡ǥѥ
 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
 *  Фʤʤ
 */
extern void	dispatch(void);

/*
 *  ǥѥåưϡcore_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡ʳߥå֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void	start_dispatch(void) NoReturn;

/*
 *  ߤΥƥȤΤƤƥǥѥåcore_support.S
 *
 *  exit_and_dispatchϡext_tskƤӽФ٤Τǡƥ
 *  ȡCPUå֡ǥѥåľ֡ʥǥΡ˳ͥ
 *  ٥ޥ֤ǸƤӽФʤФʤʤ
 */
extern void	exit_and_dispatch(void) NoReturn;

/*
 *  ͥνλθƽФcore_support.S
 *
 *  call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *  ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *  
 */
extern void call_exit_kernel(void) NoReturn;

/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ롥
 */
extern void	start_r(void);

#define activate_context(p_tcb)											\
{																		\
	(p_tcb)->tskctxb.sp = (void *)((char *)((p_tcb)->p_tinib->stk)		\
										+ (p_tcb)->p_tinib->stksz);		\
	(p_tcb)->tskctxb.pc = (void *) start_r;								\
}

/*
 *  calltexϻѤʤ
 */
#define OMIT_CALLTEX

/*
 *  ߤCPU㳰˴ؤ
 *H8/300HǤCPU㳰ʤ¾ȤθߴΤᡢ
 *CPU㳰˴ؤƤϥߡѰդ롣
 */

/*
 * å¸˴ޤޤɸ㳰ǽνѤʤ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPU㳰ϥɥν
 */
Inline void
initialize_exception(void)
{
}

/*
 *  ߥϥɥֹCPU㳰ϥɥֹϰϤȽ
 */
#define VALID_INHNO(inhno)		VALID_INTNO_CFGINT((INTNO)(inhno))
#define VALID_EXCNO(excno)		false

/*
 *  ߥϥɥ
 *
 *  ٥ȥֹinhnoγߥϥɥεưϤinthdrꤹ롥
 *  H8/300HǤϲʤ
 *  饤ؿˤȰ̤ѤǤݤηٹ𤬽ФΤǡ
 *  ޥȤƤ롣
 */
#define x_define_inh(inhno, inthdr)	assert(VALID_INHNO(inhno))


/*
 *  CPU㳰ϥɥ
 *
 *  ٥ȥֹinhnoγߥϥɥεưϤinthdrꤹ롥
 *  H8/300HǤϲʤ
 *  饤ؿˤȰ̤ѤǤݤηٹ𤬽ФΤǡ
 *  ޥȤƤ롣
 */
#define x_define_inh(inhno, inthdr)	assert(VALID_INHNO(inhno))

/*
 *  ߥϥɥޥ
 */

/*
 * C롼δؿ̾Υ٥ޥCѡ
 *     ֹ٥˴ޤΤϡƱC롼
 *     ۤʤֹʣϿ륱б뤿ᡣ
 */
#define	INT_ENTRY(inhno, inthdr)	_kernel_##inthdr##_entry_##inhno

/*
 *  CPU㳰ϥɥޥ
 *  H8/300HǤϻѤʤ
 */
#define INTHDR_ENTRY(inhno, inhno_num, inthdr)	extern void _kernel_##inthdr##_entry_##inhno(void);

/*
 *  CPU㳰ϥɥޥ
 *  H8/300HǤϻѤʤ
 */

#define EXC_ENTRY(exchdr)	exchdr##_entry
#define EXCHDR_ENTRY(exchdr)

/*
 *  CPU㳰ȯΥƥȤλ
 *ʥߡ
 *
 *  CPU㳰ȯΥƥȤƥȤλfalse
 *  Ǥʤtrue֤
 */
#define exc_sense_context(p_excinf)		false	/*  ߡ  */

/*
 *  CPU㳰ȯΥƥȤȳߤΥޥ֤λ
 *ʥߡ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤʥ
 *  ǥΡ˳ͥ٥ޥ֤ǤtrueǤʤ
 *  false֤CPU㳰ͥγ߽ȯ
 *  ˤfalse֤ˡ
 */
#define exc_sense_intmask(p_excinf)		false	/*  ߡ  */

/*
 *  CPU㳰ȯΥƥȤȳߡCPUå֤λ
 *ʥߡ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤ
 *  trueǤʤfalse֤CPU㳰ͥγ߽
 *  ȯˤfalse֤ˡ
 */
#define exc_sense_unlock(p_excinf)		false	/*  ߡ  */

/*
 *  ץå¸ν
 */
extern void	prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void	prc_terminate(void);


/*****ʲȤΥ󥿡ե˴ޤޤʤʬ*********/

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * ̤ȯΥ顼 (core_config.c, core_support.S)
 */
extern void default_int_handler(uint32_t *sp, uint8_t vector_no) throw();
#endif	/*  OMIT_DEFAULT_INT_HANDLER  */

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CORE_CONFIG_H */
